package asd.td1;

/**
 * Une classe pour les suites d'entiers, pour les exercices 7  10 de la
 * feuille 1.
 * Une suite d'entiers (ou plus simplement, une suite) est un objet contenant
 * des entiers. On ne peut pas modifier une suite (c'est  dire ajouter ou 
 * retirer un entier de la suite). On accde aux lments de la suite via un
 * curseur.
 */
public class Suite {

    // la suite est implmente  l'aide d'un tableau et d'un indice
    // (le curseur)

    private int[] t;
    private int i;

    /**
     * Construit une suite contenant exactement les lments de table.
     * Complexit : O(1).
     */
    public Suite(int[] table) {
	t = table;
	i = 0;
    }

    /**
     * Construit la suite vide.
     * Complexit : O(1).
     */
    public Suite() {
	t = new int[0];
	i = 0;
    }

    /**
     * Place le curseur de la suite au dbut (c'est  dire sur le premier
     * lment ou en fin de suite si la suite est vide).
     * Complexit : O(1).
     */
    public void debut() {
	i = 0;
    }

    /**
     * Si le curseur n'est pas en fin de suite, retourne l'entier point
     * par le curseur.
     * Prcondition : fin() = false.
     * Complexit : O(1).
     */
    public int valeurCourante() {
	return t[i];
    }

    /**
     * Si le curseur n'est pas en fin de suite, dplace le curseur sur
     * l'lment suivant, ou en fin de suite si l'lment courant tait
     * le dernier.
     * Prcondition : fin() = false.
     * Complexit : O(1).
     */
    public void suivant() {
	i++;
    }

    /**
     * Indique si on est en fin de suite, autrement dit si le curseur pointe
     * au-del du dernier lment.
     * Complexit : O(1).
     */
    public boolean fin() {
	return i == t.length;
    }
    
    // pour afficher l'lment courant
    //
    private String toString(int j) {
	if ( j == i ) {
	    return "|" + String.valueOf(t[j]) + "|";
	}
	else {
	    return String.valueOf(t[j]);
	}
    }

    /**
     * La reprsentation externe d'une suite.
     * Complexit : THETA(n) o n est la longueur de la suite.
     */
    public String toString() {
	if ( t.length == 0 ) {
	    return "<>";
	}
	String s = "<" + toString(0);
	for ( int j = 1; j < t.length; j++ ) {
	    s = s + ", " + toString(j);
	}
	s = s + ">";
	return s;
    }

    // Une suite est reprsente par <AV,vC,AP> o <AV> est la sous-suite des
    // lments placs AVant la valeur courante (les lments lus), vC la
    // valeur courante et <AP> la sous-suite des lments placs APrs la
    // valeur courante (les lments  lire).

    // Exercice 7 /////////////////////////////////////////////////////////

    /**
     * Teste si la suite est croissante.
     */
    public boolean croissante() {
	return false;
    }

    // Exercice 8 /////////////////////////////////////////////////////////

    /**
     * Retourne le nombre de monotonies de la suite.
     */
    public int monotonies() {
        return 0;
    }

    // Exercice 9 /////////////////////////////////////////////////////////

    /**
     * Retourne la longueur d'une plus longue monotonie croissante
     * de la suite.
     */
    public int longueur() {
        return 0;
    }

    // Exercice 10 /////////////////////////////////////////////////////////

    /**
     * Avance le curseur sur la premire valeur diffrente de la valeur
     * courante.
     * Prcondition : fin() est faux.
     */
    private void suivantDifferent() {
    }

    /**
     * Teste si this et s sont semblables.
     * Complexit : O(n + m) o n et m sont respectivement
     * les longueurs de this et de s.
     */
    public boolean semblable(Suite s) {
        return false;
    }
}
